// Generated with hyprwayland-scanner 0.1.0. Made with vaxry's keyboard and ❤️.
// tearing_control_v1

/*
 This protocol's authors' copyright notice is:


    Copyright © 2021 Xaver Hugl

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice (including the next
    paragraph) shall be included in all copies or substantial portions of the
    Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.
  
*/

#pragma once

#include <functional>
#include <cstdint>
#include <wayland-server.h>

#define F std::function

struct wl_client;
struct wl_resource;

enum wpTearingControlManagerV1Error : uint32_t {
    ERROR_TEARING_CONTROL_EXISTS = 0,
};

enum wpTearingControlV1PresentationHint : uint32_t {
    PRESENTATION_HINT_VSYNC = 0,
    PRESENTATION_HINT_ASYNC = 1,
};

extern const wl_interface wp_tearing_control_manager_v1_interface;
extern const wl_interface wp_tearing_control_v1_interface;

class CWpTearingControlManagerV1 {
  public:
    CWpTearingControlManagerV1(wl_client* client, uint32_t version, uint32_t id);
    ~CWpTearingControlManagerV1();

    // set a listener for when this resource is _being_ destroyed
    void setOnDestroy(F<void(CWpTearingControlManagerV1*)> handler) {
        onDestroy = handler;
    }

    // set the data for this resource
    void setData(void* data) {
        pData = data;
    }

    // get the data for this resource
    void* data() {
        return pData;
    }
    
    // get the raw wl_resource ptr
    wl_resource* resource() {
        return pResource;
    }


    // --------------- Requests --------------- //

    void setDestroy(F<void(CWpTearingControlManagerV1*)> handler);
    void setGetTearingControl(F<void(CWpTearingControlManagerV1*, uint32_t, wl_resource*)> handler);

    // --------------- Events --------------- //


  private:
    struct {
        F<void(CWpTearingControlManagerV1*)> destroy;
        F<void(CWpTearingControlManagerV1*, uint32_t, wl_resource*)> getTearingControl;
    } requests;

    void onDestroyCalled();

    F<void(CWpTearingControlManagerV1*)> onDestroy;

    wl_resource* pResource = nullptr;

    wl_listener resourceDestroyListener;

    void* pData = nullptr;
};


class CWpTearingControlV1 {
  public:
    CWpTearingControlV1(wl_client* client, uint32_t version, uint32_t id);
    ~CWpTearingControlV1();

    // set a listener for when this resource is _being_ destroyed
    void setOnDestroy(F<void(CWpTearingControlV1*)> handler) {
        onDestroy = handler;
    }

    // set the data for this resource
    void setData(void* data) {
        pData = data;
    }

    // get the data for this resource
    void* data() {
        return pData;
    }
    
    // get the raw wl_resource ptr
    wl_resource* resource() {
        return pResource;
    }


    // --------------- Requests --------------- //

    void setSetPresentationHint(F<void(CWpTearingControlV1*, wpTearingControlV1PresentationHint)> handler);
    void setDestroy(F<void(CWpTearingControlV1*)> handler);

    // --------------- Events --------------- //


  private:
    struct {
        F<void(CWpTearingControlV1*, wpTearingControlV1PresentationHint)> setPresentationHint;
        F<void(CWpTearingControlV1*)> destroy;
    } requests;

    void onDestroyCalled();

    F<void(CWpTearingControlV1*)> onDestroy;

    wl_resource* pResource = nullptr;

    wl_listener resourceDestroyListener;

    void* pData = nullptr;
};



#undef F
